// $Id: Unicode.js,v 1.1.2.6 2005/07/14 02:09:11 vnagarjuna Exp $ -->

//Copyright 2005 Nagarjuna Venna <vnagarjuna@yahoo.com>

/* ***** BEGIN LICENSE BLOCK ***** 
 *  This file is part of Padma.
 *
 *  Padma is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Padma is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Padma; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * ***** END LICENSE BLOCK ***** */

//Unicode
function Unicode() 
{
}

Unicode.maxLookupLen = 2;
Unicode.Telugu = new Object();

//Various Signs
Unicode.Telugu.candrabindu = "\u0C01";
Unicode.Telugu.anusvara    = "\u0C02";  //sunna
Unicode.Telugu.visarga     = "\u0C03";

//Independent Vowels
Unicode.Telugu.letter_A    = "\u0C05";
Unicode.Telugu.letter_AA   = "\u0C06";
Unicode.Telugu.letter_I    = "\u0C07";
Unicode.Telugu.letter_II   = "\u0C08";
Unicode.Telugu.letter_U    = "\u0C09";
Unicode.Telugu.letter_UU   = "\u0C0A";
Unicode.Telugu.letter_R    = "\u0C0B";   //vocalic R
Unicode.Telugu.letter_RR   = "\u0C60";   //vocalic R
Unicode.Telugu.letter_L    = "\u0C0C";   //vocalic L
Unicode.Telugu.letter_LL   = "\u0C61";   //vocalic L
Unicode.Telugu.letter_E    = "\u0C0E";
Unicode.Telugu.letter_EE   = "\u0C0F";
Unicode.Telugu.letter_AI   = "\u0C10";
Unicode.Telugu.letter_O    = "\u0C12";
Unicode.Telugu.letter_OO   = "\u0C13";
Unicode.Telugu.letter_AU   = "\u0C14";

//Consonants
Unicode.Telugu.letter_KA   = "\u0C15";
Unicode.Telugu.letter_KHA  = "\u0C16";
Unicode.Telugu.letter_GA   = "\u0C17";
Unicode.Telugu.letter_GHA  = "\u0C18";
Unicode.Telugu.letter_NGA  = "\u0C19";
Unicode.Telugu.letter_CA   = "\u0C1A";
Unicode.Telugu.letter_CHA  = "\u0C1B";
Unicode.Telugu.letter_JA   = "\u0C1C";
Unicode.Telugu.letter_JHA  = "\u0C1D";
Unicode.Telugu.letter_NYA  = "\u0C1E";
Unicode.Telugu.letter_TTA  = "\u0C1F";
Unicode.Telugu.letter_TTHA = "\u0C20";
Unicode.Telugu.letter_DDA  = "\u0C21";
Unicode.Telugu.letter_DDHA = "\u0C22";
Unicode.Telugu.letter_NNA  = "\u0C23";
Unicode.Telugu.letter_TA   = "\u0C24";
Unicode.Telugu.letter_THA  = "\u0C25";
Unicode.Telugu.letter_DA   = "\u0C26";
Unicode.Telugu.letter_DHA  = "\u0C27";
Unicode.Telugu.letter_NA   = "\u0C28";
Unicode.Telugu.letter_PA   = "\u0C2A";
Unicode.Telugu.letter_PHA  = "\u0C2B";
Unicode.Telugu.letter_BA   = "\u0C2C";
Unicode.Telugu.letter_BHA  = "\u0C2D";
Unicode.Telugu.letter_MA   = "\u0C2E";
Unicode.Telugu.letter_YA   = "\u0C2F";
Unicode.Telugu.letter_RA   = "\u0C30";
Unicode.Telugu.letter_RRA  = "\u0C31";
Unicode.Telugu.letter_LA   = "\u0C32";
Unicode.Telugu.letter_LLA  = "\u0C33";
Unicode.Telugu.letter_VA   = "\u0C35";
Unicode.Telugu.letter_SHA  = "\u0C36";
Unicode.Telugu.letter_SSA  = "\u0C37";
Unicode.Telugu.letter_SA   = "\u0C38";
Unicode.Telugu.letter_HA   = "\u0C39";

//Dependent Vowel Signs
Unicode.Telugu.vowelsn_AA  = "\u0C3E";
Unicode.Telugu.vowelsn_I   = "\u0C3F";
Unicode.Telugu.vowelsn_II  = "\u0C40";
Unicode.Telugu.vowelsn_U   = "\u0C41";
Unicode.Telugu.vowelsn_UU  = "\u0C42";
Unicode.Telugu.vowelsn_R   = "\u0C43";
Unicode.Telugu.vowelsn_RR  = "\u0C44";
Unicode.Telugu.vowelsn_E   = "\u0C46";
Unicode.Telugu.vowelsn_EE  = "\u0C47";
Unicode.Telugu.vowelsn_AI  = "\u0C48";   //this is the same as 0C46 followed by 0C56
Unicode.Telugu.vowelsn_O   = "\u0C4A";
Unicode.Telugu.vowelsn_OO  = "\u0C4B";
Unicode.Telugu.vowelsn_AU  = "\u0C4C";

//Miscellaneous Signs
Unicode.Telugu.misc_VIRAMA   = "\u0C4D";   //halant
Unicode.Telugu.misc_LENGTH   = "\u0C55";
Unicode.Telugu.misc_AILEN    = "\u0C56";
Unicode.Telugu.misc_AVAGRAHA = "\u093D";
Unicode.misc_NUKTA    = "\u093C";
Unicode.misc_UDATTA   = "\u0951";
Unicode.misc_ANUDATTA = "\u0952";
Unicode.misc_SVARITA  = "\u0951";
Unicode.misc_DANDA    = "\u0964";
Unicode.misc_DDANDA   = "\u0965";

//Ligatures
Unicode.Telugu.ligature_KSH = "\u0C15\u0C4D\u0C37";
//nukt
Unicode.Telugu.nukt_TCH     = "\u0C1A\u093C\u0C4D";
Unicode.Telugu.nukt_TJ      = "\u0C1C\u093C\u0C4D";
//Miscellaneous
Unicode.Telugu.conjuct_JNY  = "\u0C1C\u0C4D\u0C1E";
Unicode.Telugu.conjuct_DDDD = "\u0C21\u0C4D\u0C21";
Unicode.Telugu.conjuct_TTTT = "\u0C1F\u0C$D\u0C1F";

//Digits
Unicode.Telugu.digit_ZERO  = "\u0C66";
Unicode.Telugu.digit_ONE   = "\u0C67";
Unicode.Telugu.digit_TWO   = "\u0C68";
Unicode.Telugu.digit_THREE = "\u0C69";
Unicode.Telugu.digit_FOUR  = "\u0C6A";
Unicode.Telugu.digit_FIVE  = "\u0C6B";
Unicode.Telugu.digit_SIX   = "\u0C6C";
Unicode.Telugu.digit_SEVEN = "\u0C6D";
Unicode.Telugu.digit_EIGHT = "\u0C6E";
Unicode.Telugu.digit_NINE  = "\u0C6F";

//Zero-Width Joiner/Non Joiner for Virama
Unicode.misc_ZWNJ   = "\u200C";
Unicode.misc_ZWJ    = "\u200D";

//Unsupported transfromations are just commented out
Unicode.fromPadma = new Array();

Unicode.fromPadma[Padma.candrabindu] = Unicode.Telugu.candrabindu;
Unicode.fromPadma[Padma.visarga]     = Unicode.Telugu.visarga;
Unicode.fromPadma[Padma.pollu]       = Unicode.Telugu.misc_VIRAMA + Unicode.misc_ZWNJ;
Unicode.fromPadma[Padma.anusvara]    = Unicode.Telugu.anusvara;
Unicode.fromPadma[Padma.avagraha]    = Unicode.Telugu.misc_AVAGRAHA;
//Unicode.fromPadma[Padma.yati]      = Unicode.misc_YATI;
Unicode.fromPadma[Padma.udAtta]      = Unicode.misc_UDATTA;
Unicode.fromPadma[Padma.anudAtta]    = Unicode.misc_ANUDATTA;
Unicode.fromPadma[Padma.svarita]     = Unicode.misc_SVARITA;
//Unicode.fromPadma[Padma.guru]      = Unicode.misc_GURU;
//Unicode.fromPadma[Padma.laghu]     = Unicode.misc_LAGHU;
Unicode.fromPadma[Padma.danda]       = Unicode.misc_DANDA;
Unicode.fromPadma[Padma.ddanda]      = Unicode.misc_DDANDA;

//digits
Unicode.fromPadma[Padma.digit_ZERO]  = Unicode.Telugu.digit_ZERO;
Unicode.fromPadma[Padma.digit_ONE]   = Unicode.Telugu.digit_ONE;
Unicode.fromPadma[Padma.digit_TWO]   = Unicode.Telugu.digit_TWO;
Unicode.fromPadma[Padma.digit_THREE] = Unicode.Telugu.digit_THREE;
Unicode.fromPadma[Padma.digit_FOUR]  = Unicode.Telugu.digit_FOUR;
Unicode.fromPadma[Padma.digit_FIVE]  = Unicode.Telugu.digit_FIVE;
Unicode.fromPadma[Padma.digit_SIX]   = Unicode.Telugu.digit_SIX;
Unicode.fromPadma[Padma.digit_SEVEN] = Unicode.Telugu.digit_SEVEN;
Unicode.fromPadma[Padma.digit_EIGHT] = Unicode.Telugu.digit_EIGHT;
Unicode.fromPadma[Padma.digit_NINE]  = Unicode.Telugu.digit_NINE;

//Vowels
Unicode.fromPadma[Padma.vowel_A]     = Unicode.Telugu.letter_A;
Unicode.fromPadma[Padma.vowel_AA]    = Unicode.Telugu.letter_AA;
Unicode.fromPadma[Padma.vowel_I]     = Unicode.Telugu.letter_I;
Unicode.fromPadma[Padma.vowel_II]    = Unicode.Telugu.letter_II;
Unicode.fromPadma[Padma.vowel_U]     = Unicode.Telugu.letter_U;
Unicode.fromPadma[Padma.vowel_UU]    = Unicode.Telugu.letter_UU;
Unicode.fromPadma[Padma.vowel_R]     = Unicode.Telugu.letter_R;
Unicode.fromPadma[Padma.vowel_RR]    = Unicode.Telugu.letter_RR;
Unicode.fromPadma[Padma.vowel_L]     = Unicode.Telugu.letter_L;
Unicode.fromPadma[Padma.vowel_LL]    = Unicode.Telugu.letter_LL;
Unicode.fromPadma[Padma.vowel_E]     = Unicode.Telugu.letter_E;
Unicode.fromPadma[Padma.vowel_EE]    = Unicode.Telugu.letter_EE;
Unicode.fromPadma[Padma.vowel_AI]    = Unicode.Telugu.letter_AI;
Unicode.fromPadma[Padma.vowel_O]     = Unicode.Telugu.letter_O;
Unicode.fromPadma[Padma.vowel_OO]    = Unicode.Telugu.letter_OO;
Unicode.fromPadma[Padma.vowel_AU]    = Unicode.Telugu.letter_AU;

//Consonants
Unicode.fromPadma[Padma.consnt_KA]   = Unicode.Telugu.letter_KA;
Unicode.fromPadma[Padma.consnt_KHA]  = Unicode.Telugu.letter_KHA;
Unicode.fromPadma[Padma.consnt_GA]   = Unicode.Telugu.letter_GA;
Unicode.fromPadma[Padma.consnt_GHA]  = Unicode.Telugu.letter_GHA;
Unicode.fromPadma[Padma.consnt_NGA]  = Unicode.Telugu.letter_NGA;
Unicode.fromPadma[Padma.consnt_CA]   = Unicode.Telugu.letter_CA;
Unicode.fromPadma[Padma.consnt_CHA]  = Unicode.Telugu.letter_CHA;
Unicode.fromPadma[Padma.consnt_JA]   = Unicode.Telugu.letter_JA;
Unicode.fromPadma[Padma.consnt_JHA]  = Unicode.Telugu.letter_JHA;
Unicode.fromPadma[Padma.consnt_NYA]  = Unicode.Telugu.letter_NYA;
Unicode.fromPadma[Padma.consnt_TTA]  = Unicode.Telugu.letter_TTA;
Unicode.fromPadma[Padma.consnt_TTHA] = Unicode.Telugu.letter_TTHA;
Unicode.fromPadma[Padma.consnt_DDA]  = Unicode.Telugu.letter_DDA;
Unicode.fromPadma[Padma.consnt_DDHA] = Unicode.Telugu.letter_DDHA;
Unicode.fromPadma[Padma.consnt_NNA]  = Unicode.Telugu.letter_NNA;
Unicode.fromPadma[Padma.consnt_TA]   = Unicode.Telugu.letter_TA;
Unicode.fromPadma[Padma.consnt_THA]  = Unicode.Telugu.letter_THA;
Unicode.fromPadma[Padma.consnt_DA]   = Unicode.Telugu.letter_DA;
Unicode.fromPadma[Padma.consnt_DHA]  = Unicode.Telugu.letter_DHA;
Unicode.fromPadma[Padma.consnt_NA]   = Unicode.Telugu.letter_NA;
Unicode.fromPadma[Padma.consnt_PA]   = Unicode.Telugu.letter_PA;
Unicode.fromPadma[Padma.consnt_PHA]  = Unicode.Telugu.letter_PHA;
Unicode.fromPadma[Padma.consnt_BA]   = Unicode.Telugu.letter_BA;
Unicode.fromPadma[Padma.consnt_BHA]  = Unicode.Telugu.letter_BHA;
Unicode.fromPadma[Padma.consnt_MA]   = Unicode.Telugu.letter_MA;
Unicode.fromPadma[Padma.consnt_YA]   = Unicode.Telugu.letter_YA;
Unicode.fromPadma[Padma.consnt_RA]   = Unicode.Telugu.letter_RA;
Unicode.fromPadma[Padma.consnt_LA]   = Unicode.Telugu.letter_LA;
Unicode.fromPadma[Padma.consnt_VA]   = Unicode.Telugu.letter_VA;
Unicode.fromPadma[Padma.consnt_SHA]  = Unicode.Telugu.letter_SHA;
Unicode.fromPadma[Padma.consnt_SSA]  = Unicode.Telugu.letter_SSA;
Unicode.fromPadma[Padma.consnt_SA]   = Unicode.Telugu.letter_SA;
Unicode.fromPadma[Padma.consnt_HA]   = Unicode.Telugu.letter_HA;
Unicode.fromPadma[Padma.consnt_LLA]  = Unicode.Telugu.letter_LLA;
Unicode.fromPadma[Padma.consnt_KSH]  = Unicode.Telugu.ligature_KSH;
Unicode.fromPadma[Padma.consnt_RRA]  = Unicode.Telugu.letter_RRA;

//extinct consonants
Unicode.fromPadma[Padma.consnt_TCH]  = Unicode.Telugu.nukt_TCH;
Unicode.fromPadma[Padma.consnt_TJ]   = Unicode.Telugu.nukt_TJ;

//Gunimtaalu
Unicode.fromPadma[Padma.vowelsn_AA]  = Unicode.Telugu.vowelsn_AA;
Unicode.fromPadma[Padma.vowelsn_I]   = Unicode.Telugu.vowelsn_I;
Unicode.fromPadma[Padma.vowelsn_II]  = Unicode.Telugu.vowelsn_II;
Unicode.fromPadma[Padma.vowelsn_U]   = Unicode.Telugu.vowelsn_U;
Unicode.fromPadma[Padma.vowelsn_UU]  = Unicode.Telugu.vowelsn_UU;
Unicode.fromPadma[Padma.vowelsn_R]   = Unicode.Telugu.vowelsn_R;
Unicode.fromPadma[Padma.vowelsn_RR]  = Unicode.Telugu.vowelsn_RR;
//Unicode.fromPadma[Padma.vowelsn_L]   = Unicode.Telugu.vowelsn_L;
//Unicode.fromPadma[Padma.vowelsn_LL]  = Unicode.Telugu.vowelsn_LL;
Unicode.fromPadma[Padma.vowelsn_E]   = Unicode.Telugu.vowelsn_E;
Unicode.fromPadma[Padma.vowelsn_EE]  = Unicode.Telugu.vowelsn_EE;
Unicode.fromPadma[Padma.vowelsn_AI]  = Unicode.Telugu.vowelsn_AI;
Unicode.fromPadma[Padma.vowelsn_O]   = Unicode.Telugu.vowelsn_O;
Unicode.fromPadma[Padma.vowelsn_OO]  = Unicode.Telugu.vowelsn_OO;
Unicode.fromPadma[Padma.vowelsn_AU]  = Unicode.Telugu.vowelsn_AU;
Unicode.fromPadma[Padma.vowelsn_AILEN]  = Unicode.Telugu.misc_AILEN;

Unicode.toPadma = new Array();

Unicode.toPadma[Unicode.Telugu.candrabindu]   = Padma.candrabindu;
Unicode.toPadma[Unicode.Telugu.visarga]       = Padma.visarga;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.misc_ZWNJ] = Padma.pollu;
Unicode.toPadma[Unicode.Telugu.anusvara]      = Padma.anusvara;
Unicode.toPadma[Unicode.Telugu.misc_AVAGRAHA] = Padma.avagraha;
//Unicode.toPadma[Unicode.misc_YATI]   = Padma.yati;
Unicode.toPadma[Unicode.misc_UDATTA]   = Padma.udAtta;
Unicode.toPadma[Unicode.misc_ANUDATTA] = Padma.anudAtta;
Unicode.toPadma[Unicode.misc_SVARITA]  = Padma.svarita;
//Unicode.toPadma[Unicode.misc_GURU]   = Padma.guru;
//Unicode.toPadma[Unicode.misc_LAGHU]  = Padma.laghu;
Unicode.toPadma[Unicode.misc_DANDA]    = Padma.danda;;
Unicode.toPadma[Unicode.misc_DDANDA]   = Padma.ddanda;

//digits
Unicode.toPadma[Unicode.Telugu.digit_ZERO]  = Padma.digit_ZERO;
Unicode.toPadma[Unicode.Telugu.digit_ONE]   = Padma.digit_ONE;
Unicode.toPadma[Unicode.Telugu.digit_TWO]   = Padma.digit_TWO;
Unicode.toPadma[Unicode.Telugu.digit_THREE] = Padma.digit_THREE;
Unicode.toPadma[Unicode.Telugu.digit_FOUR]  = Padma.digit_FOUR;
Unicode.toPadma[Unicode.Telugu.digit_FIVE]  = Padma.digit_FIVE;
Unicode.toPadma[Unicode.Telugu.digit_SIX]   = Padma.digit_SIX;
Unicode.toPadma[Unicode.Telugu.digit_SEVEN] = Padma.digit_SEVEN;
Unicode.toPadma[Unicode.Telugu.digit_EIGHT] = Padma.digit_EIGHT;
Unicode.toPadma[Unicode.Telugu.digit_NINE]  = Padma.digit_NINE;

//Vowels
Unicode.toPadma[Unicode.Telugu.letter_A]     = Padma.vowel_A;
Unicode.toPadma[Unicode.Telugu.letter_AA]    = Padma.vowel_AA;
Unicode.toPadma[Unicode.Telugu.letter_I]     = Padma.vowel_I;
Unicode.toPadma[Unicode.Telugu.letter_II]    = Padma.vowel_II;
Unicode.toPadma[Unicode.Telugu.letter_U]     = Padma.vowel_U;
Unicode.toPadma[Unicode.Telugu.letter_UU]    = Padma.vowel_UU;
Unicode.toPadma[Unicode.Telugu.letter_R]     = Padma.vowel_R;
Unicode.toPadma[Unicode.Telugu.letter_RR]    = Padma.vowel_RR;
Unicode.toPadma[Unicode.Telugu.letter_L]     = Padma.vowel_L;
Unicode.toPadma[Unicode.Telugu.letter_LL]    = Padma.vowel_LL;
Unicode.toPadma[Unicode.Telugu.letter_E]     = Padma.vowel_E;
Unicode.toPadma[Unicode.Telugu.letter_EE]    = Padma.vowel_EE;
Unicode.toPadma[Unicode.Telugu.letter_AI]    = Padma.vowel_AI;
Unicode.toPadma[Unicode.Telugu.letter_O]     = Padma.vowel_O;
Unicode.toPadma[Unicode.Telugu.letter_OO]    = Padma.vowel_OO;
Unicode.toPadma[Unicode.Telugu.letter_AU]    = Padma.vowel_AU;

//Consonants
Unicode.toPadma[Unicode.Telugu.letter_KA]    = Padma.consnt_KA;
Unicode.toPadma[Unicode.Telugu.letter_KHA]   = Padma.consnt_KHA;
Unicode.toPadma[Unicode.Telugu.letter_GA]    = Padma.consnt_GA;
Unicode.toPadma[Unicode.Telugu.letter_GHA]   = Padma.consnt_GHA;
Unicode.toPadma[Unicode.Telugu.letter_NGA]   = Padma.consnt_NGA;
Unicode.toPadma[Unicode.Telugu.letter_CA]    = Padma.consnt_CA;
Unicode.toPadma[Unicode.Telugu.letter_CHA]   = Padma.consnt_CHA;
Unicode.toPadma[Unicode.Telugu.letter_JA]    = Padma.consnt_JA;
Unicode.toPadma[Unicode.Telugu.letter_JHA]   = Padma.consnt_JHA;
Unicode.toPadma[Unicode.Telugu.letter_NYA]   = Padma.consnt_NYA;
Unicode.toPadma[Unicode.Telugu.letter_TTA]   = Padma.consnt_TTA;
Unicode.toPadma[Unicode.Telugu.letter_TTHA]  = Padma.consnt_TTHA;
Unicode.toPadma[Unicode.Telugu.letter_DDA]   = Padma.consnt_DDA;
Unicode.toPadma[Unicode.Telugu.letter_DDHA]  = Padma.consnt_DDHA;
Unicode.toPadma[Unicode.Telugu.letter_NNA]   = Padma.consnt_NNA;
Unicode.toPadma[Unicode.Telugu.letter_TA]    = Padma.consnt_TA;
Unicode.toPadma[Unicode.Telugu.letter_THA]   = Padma.consnt_THA;
Unicode.toPadma[Unicode.Telugu.letter_DA]    = Padma.consnt_DA;
Unicode.toPadma[Unicode.Telugu.letter_DHA]   = Padma.consnt_DHA;
Unicode.toPadma[Unicode.Telugu.letter_NA]    = Padma.consnt_NA;
Unicode.toPadma[Unicode.Telugu.letter_PA]    = Padma.consnt_PA;
Unicode.toPadma[Unicode.Telugu.letter_PHA]   = Padma.consnt_PHA;
Unicode.toPadma[Unicode.Telugu.letter_BA]    = Padma.consnt_BA;
Unicode.toPadma[Unicode.Telugu.letter_BHA]   = Padma.consnt_BHA;
Unicode.toPadma[Unicode.Telugu.letter_MA]    = Padma.consnt_MA;
Unicode.toPadma[Unicode.Telugu.letter_YA]    = Padma.consnt_YA;
Unicode.toPadma[Unicode.Telugu.letter_RA]    = Padma.consnt_RA;
Unicode.toPadma[Unicode.Telugu.letter_LA]    = Padma.consnt_LA;
Unicode.toPadma[Unicode.Telugu.letter_VA]    = Padma.consnt_VA;
Unicode.toPadma[Unicode.Telugu.letter_SHA]   = Padma.consnt_SHA;
Unicode.toPadma[Unicode.Telugu.letter_SSA]   = Padma.consnt_SSA;
Unicode.toPadma[Unicode.Telugu.letter_SA]    = Padma.consnt_SA;
Unicode.toPadma[Unicode.Telugu.letter_HA]    = Padma.consnt_HA;
Unicode.toPadma[Unicode.Telugu.letter_LLA]   = Padma.consnt_LLA;
Unicode.toPadma[Unicode.Telugu.ligature_KSH] = Padma.consnt_KSH;
Unicode.toPadma[Unicode.Telugu.letter_RRA]   = Padma.consnt_RRA;
Unicode.toPadma[Unicode.Telugu.nukt_TCH]     = Padma.consnt_TCH;
Unicode.toPadma[Unicode.Telugu.nukt_TJ]      = Padma.consnt_TJ;

//Gunimtaalu
Unicode.toPadma[Unicode.Telugu.vowelsn_AA]  = Padma.vowelsn_AA;
Unicode.toPadma[Unicode.Telugu.vowelsn_I]   = Padma.vowelsn_I;
Unicode.toPadma[Unicode.Telugu.vowelsn_II]  = Padma.vowelsn_II;
Unicode.toPadma[Unicode.Telugu.vowelsn_U]   = Padma.vowelsn_U;
Unicode.toPadma[Unicode.Telugu.vowelsn_UU]  = Padma.vowelsn_UU;
Unicode.toPadma[Unicode.Telugu.vowelsn_R]   = Padma.vowelsn_R;
Unicode.toPadma[Unicode.Telugu.vowelsn_RR]  = Padma.vowelsn_RR;
//Unicode.toPadma[Unicode.Telugu.vowelsn_L]   = Padma.vowelsn_L;
//Unicode.toPadma[Unicode.Telugu.vowelsn_LL]  = Padma.vowelsn_LL;
Unicode.toPadma[Unicode.Telugu.vowelsn_E]   = Padma.vowelsn_E;
Unicode.toPadma[Unicode.Telugu.vowelsn_EE]  = Padma.vowelsn_EE;
Unicode.toPadma[Unicode.Telugu.vowelsn_AI]  = Padma.vowelsn_AI;
Unicode.toPadma[Unicode.Telugu.vowelsn_O]   = Padma.vowelsn_O;
Unicode.toPadma[Unicode.Telugu.vowelsn_OO]  = Padma.vowelsn_OO;
Unicode.toPadma[Unicode.Telugu.vowelsn_AU]  = Padma.vowelsn_AU;
Unicode.toPadma[Unicode.Telugu.misc_AILEN]  = Padma.vowelsn_AILEN;

//Vattulu
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_KA]    = Padma.vattu_KA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_KHA]   = Padma.vattu_KHA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_GA]    = Padma.vattu_GA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_GHA]   = Padma.vattu_GHA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_NGA]   = Padma.vattu_NGA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_CA]    = Padma.vattu_CA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_CHA]   = Padma.vattu_CHA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_JA]    = Padma.vattu_JA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_JHA]   = Padma.vattu_JHA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_NYA]   = Padma.vattu_NYA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_TTA]   = Padma.vattu_TTA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_TTHA]  = Padma.vattu_TTHA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_DDA]   = Padma.vattu_DDA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_DDHA]  = Padma.vattu_DDHA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_NNA]   = Padma.vattu_NNA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_TA]    = Padma.vattu_TA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_THA]   = Padma.vattu_THA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_DA]    = Padma.vattu_DA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_DHA]   = Padma.vattu_DHA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_NA]    = Padma.vattu_NA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_PA]    = Padma.vattu_PA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_PHA]   = Padma.vattu_PHA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_BA]    = Padma.vattu_BA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_BHA]   = Padma.vattu_BHA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_MA]    = Padma.vattu_MA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_YA]    = Padma.vattu_YA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_RA]    = Padma.vattu_RA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_LA]    = Padma.vattu_LA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_VA]    = Padma.vattu_VA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_SHA]   = Padma.vattu_SHA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_SSA]   = Padma.vattu_SSA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_SA]    = Padma.vattu_SA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_HA]    = Padma.vattu_HA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_LLA]   = Padma.vattu_LLA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.ligature_KSH] = Padma.vattu_KSH;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.letter_RRA]   = Padma.vattu_RRA;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.nukt_TCH]     = Padma.vattu_TCH;
Unicode.toPadma[Unicode.Telugu.misc_VIRAMA + Unicode.Telugu.nukt_TJ]      = Padma.vattu_TJ;

Unicode.lookup = function (str) 
{
    return Unicode.toPadma[str];
}

Unicode.transformFromPadma = function (str)
{
    var ret = Unicode.fromPadma[str];
    if (ret == null) {
        var code = str.charCodeAt(0);
        if (code >= 0x80) {
            var old = Unicode.fromPadma[String.fromCharCode(code - 0x80)];
            if (old != null)
                return Unicode.Telugu.misc_VIRAMA + old;
        }
        return str;
    }
    return ret;
}
