// $Id: prefs.js,v 1.1.2.3 2005/07/17 21:22:02 vnagarjuna Exp $ -->

//Copyright 2005 Nagarjuna Venna <vnagarjuna@yahoo.com>

/* ****** BEGIN LICENSE BLOCK ***** 
 *  This file is part of Padma.
 *
 *  Padma is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Padma is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Padma; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * ***** END LICENSE BLOCK ***** */

var PadmaSettings = {
    onLoad: function() {
        var prefObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        this.branch = prefObj.getBranch("Padma.");


        this.rtsOutputButton = document.getElementById("RTSOutputFormat");
        this.autoCheck = document.getElementById("enableAutoTransform");
        this.heuristicCheck = document.getElementById("enableHeuristics");
        this.autoListUpdate = document.getElementById("updateAutoTransformList");
        this.heuristicListUpdate = document.getElementById("updateHeuristicsList");

        //RTS Output format - default = 0
        this.RTSOutputFormat = this.branch.prefHasUserValue(this.prefRTSOutputFormat) ? 
                               this.branch.getIntPref(this.prefRTSOutputFormat) : 0;
        if (this.RTSOutputFormat > 2 || this.RTSOutputFormat < 0)
            this.RTSOutputFormat = 0;
        this.rtsOutputButton.selectedIndex = this.RTSOutputFormat;

        //Auto Transform - default = true
        this.autoCheck.checked = this.branch.prefHasUserValue(this.prefEnableAutoTransform) ? 
                                 this.branch.getBoolPref(this.prefEnableAutoTransform) : true;
        if (!this.autoCheck.checked)
            this.autoListUpdate.disabled = true;
        
        //Heuristics based Transform - default = true
        this.heuristicCheck.checked = this.branch.prefHasUserValue(this.prefEnableHeuristics) ? 
                                      this.branch.getBoolPref(this.prefEnableHeuristics) : true;
        if (!this.heuristicCheck.checked)
            this.heuristicListUpdate.disabled = true;

        //White list for auto transform
        this.autoTransformWhiteList = this.branch.prefHasUserValue(this.prefAutoTransformWhiteList) ? 
                                      this.branch.getCharPref(this.prefAutoTransformWhiteList) : this.defAutoTransformWhiteList;

        //White list for heuristic transform
/*
        this.heuristicTransformWhiteList = this.branch.prefHasUserValue(this.prefHeuristicTransformWhiteList) ? 
                                           this.branch.getCharPref(this.prefHeuristicTransformWhiteList) : this.defHeuristicTransformWhiteList;
*/
    },

    onSave: function() {
        this.RTSOutputFormat = this.rtsOutputButton.selectedIndex;
        this.branch.setIntPref(this.prefRTSOutputFormat, this.rtsOutputButton.selectedIndex);

        this.branch.setBoolPref(this.prefEnableAutoTransform, this.autoCheck.checked);
        this.branch.setBoolPref(this.prefEnableHeuristics, this.heuristicCheck.checked);

        this.branch.setCharPref(this.prefAutoTransformWhiteList, this.autoTransformWhiteList);
        //this.branch.setCharPref(this.prefHeuristicTransformWhiteList, this.heuristicTransformWhiteList);
    },

    onCheckBoxUpdate: function() {
        this.autoListUpdate.disabled = !this.autoCheck.checked;
        this.heuristicListUpdate.disabled = !this.heuristicCheck.checked;
    },

    updateAutoTransformList: function() {
        var params = { input: this.autoTransformWhiteList, desc: "autoDescription", title: "Automatic Transform List", output: null };
        window.openDialog("chrome://padma/content/whitelist.xul", "updateauottransformlist", "chrome", params);
        if (params.output != null) {
            this.autoTransformWhiteList = params.output;
            this.branch.setCharPref(this.prefAutoTransformWhiteList, this.autoTransformWhiteList);
        }
    },

    updateHeuristicTransformList: function() {
        var params = { input: this.heuristicTransformWhiteList, desc: "heurDescription", title: "Heuristic Transform List", output: null };
        window.openDialog("chrome://padma/content/whitelist.xul", "updateheuristictransformlist", "chrome", params);
        if (params.output != null) {
            this.heuristicTransformWhiteList = params.output;
            this.branch.setCharPref(this.prefHeuristicTransformWhiteList, this.heuristicTransformWhiteList);
        }
    },

    defAutoTransformWhiteList: "www.eenadu.net,www.andhrajyothy.com,www.andhraprabha.com,www.apweekly.com",
    defHeuristicTransformWhiteList: "www.andhrajyothy.com",
    prefRTSOutputFormat: "RTSOutputFormat",
    prefEnableAutoTransform: "enableAutoTransform",
    prefEnableHeuristics: "enableHeuristics",
    prefAutoTransformWhiteList: "autoTransformWhiteList",
    prefHeuristicTransformWhiteList: "heuristicWhiteList",

};
