// $Id: whitelist.js,v 1.1.2.1 2005/07/17 21:22:02 vnagarjuna Exp $ -->

//Copyright 2005 Nagarjuna Venna <vnagarjuna@yahoo.com>

/* ****** BEGIN LICENSE BLOCK ***** 
 *  This file is part of Padma.
 *
 *  Padma is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Padma is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Padma; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * ***** END LICENSE BLOCK ***** */

//This code is mostly based on Flashblock's implementation of a whitelist

var PadmaWhitelist = {
    
    onLoad: function() {

        this.whitelistBox = document.getElementById("sitelist");
        this.removeButton = document.getElementById("btnRemove");
        this.addButton    = document.getElementById("btnAdd");
        this.newSiteBox   = document.getElementById("siteTextbox");

        //Load site list
        this.params = window.arguments[0];
        var sites = this.params.input.split(",");
        for(var i = 0; i < sites.length; ++i)
            this.whitelistBox.ensureElementIsVisible(this.whitelistBox.appendItem(sites[i]));

        document.getElementById(this.params.desc).hidden = false;
        if (this.params.title != null)
            window.title = this.params.title;
    },

    onSave: function() {
        //Cheap hack to enable user to add a site by pressing enter
        if (this.newSiteBox.value.length != 0) {
            this.addSite();
            return false;
        }
        var rows = this.whitelistBox.getRowCount(), whitelist = "";
        for(var i = 0; i < rows; ++i) {
            if (i != 0)
                whitelist += ",";
            whitelist += this.whitelistBox.getItemAtIndex(i).label;
        }
        this.params.output = whitelist;
        return true;
    },

    onSelected: function() {
        this.removeButton.disabled = (this.whitelistBox.selectedIndex == -1);
    },

    onNewSiteInput: function() {
        this.addButton.disabled = !this.newSiteBox.value;
    },

    addSite: function() {
        if (!this.checkSite(this.newSiteBox.value)) {
            alert("Invalid characters in site name. Valid characters are *, A-Z, 0-9, -, _ and .");
            return false;
        }

        if (!this.listHasSite(this.newSiteBox.value))
            this.whitelistBox.ensureElementIsVisible(this.whitelistBox.appendItem(this.newSiteBox.value));
            
        this.newSiteBox.value = "";
        this.addButton.disabled = true;
        this.newSiteBox.focus();
        return true;
    },

    removeSite: function() {
        if (this.whitelistBox.selectedIndex != -1) {
            var index = this.whitelistBox.selectedIndex, rows = this.whitelistBox.getRowCount();
            var selItem = this.whitelistBox.selectedItem;

            //set focus on next site unless we just deleted the last site
            if (index == rows - 1) {
                if (rows != 1)
                    this.whitelistBox.selectItem(this.whitelistBox.getPreviousItem(selItem, 1));
                else this.removeButton.disabled = true;
            }
            else this.whitelistBox.selectItem(this.whitelistBox.getNextItem(selItem, 1));
        }

        this.whitelistBox.removeItemAt(index);
    },

    removeAll: function() {
        if (confirm("Are you sure you want to remove all the sites?")) {
        var rows = this.whitelistBox.getRowCount();
        for(var i = 0; i < rows; ++i)
            this.whitelistBox.removeItemAt(0);
        }
    },

    checkSite: function(site) {
        var regex = /^[A-Za-z0-9_\-\.\*]+(\:\d{4,5}){0,1}$/; 
        return regex.test(site);
    },

    listHasSite: function(site) {
        var rows = this.whitelistBox.getRowCount();
        for(var i = 0; i < rows; ++i)
            if (this.whitelistBox.getItemAtIndex(i) == site)
                return true;

        return false;
    },
};
